#!/usr/bin/env python
# -*- coding: iso-8859-1 -*-

###
#COPYRIGHT © 2013 THE OHIO STATE UNIVERSITY
#ALL RIGHTS RESERVED
#
#PERMISSION IS GRANTED TO USE, COPY, CREATE DERIVATIVE WORKS AND
#REDISTRIBUTE THIS SOFTWARE AND SUCH DERIVATIVE WORKS FOR NONCOMMERCIAL
#EDUCATION AND RESEARCH PURPOSES, SO LONG AS NO FEE IS CHARGED, AND SO
#LONG AS THE COPYRIGHT NOTICE ABOVE, THIS GRANT OF PERMISSION, AND THE
#DISCLAIMER BELOW APPEAR IN ALL COPIES MADE; AND SO LONG AS THE NAME OF
#THE OHIO STATE UNIVERSITY IS NOT USED IN ANY ADVERTISING OR PUBLICITY
#PERTAINING TO THE USE OR DISTRIBUTION OF THIS SOFTWARE WITHOUT
#SPECIFIC, WRITTEN PRIOR AUTHORIZATION.
#
#THIS SOFTWARE IS PROVIDED AS IS, WITHOUT REPRESENTATION FROM THE OHIO
#STATE UNIVERSITY AS TO ITS FITNESS FOR ANY PURPOSE, AND WITHOUT
#WARRANTY BY THE OHIO STATE UNIVERSITY OF ANY KIND, EITHER EXPRESS OR
#IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF
#MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE OHIO STATE
#UNIVERSITY SHALL NOT BE LIABLE FOR ANY DAMAGES, INCLUDING SPECIAL,
#INDIRECT, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, WITH RESPECT TO ANY
#CLAIM ARISING OUT OF OR IN CONNECTION WITH THE USE OF THE SOFTWARE,
#EVEN IF IT HAS BEEN OR IS HEREAFTER ADVISED OF THE POSSIBILITY OF SUCH
#DAMAGES.
###

try:
    import MethMAGE
    import argparse
except (ImportError),err: raise

def main(ssnroisA,ssnroisB,Alabel,Blabel,out,plots_out,nthreads):
    print out,Alabel,ssnroisA,Blabel,ssnroisB,nthreads
    start = MethMAGE.MethMAGE()
    start.methmage(ssnroisA,ssnroisB,Alabel,Blabel,out,plots_out)
    return


if __name__ == '__main__':
    import argparse
    import sys
    import datetime
    import os

    # process specific information
    __date = datetime.datetime.now().strftime('%Y%m%d:%H%M%S')
    __pid = os.getpid()

    parser = argparse.ArgumentParser(description='Generate MethMAGE')
    parser.add_argument('--plots_out',dest='plots_out',nargs=1,type=str,
                        default=[sys.stdout],help='Output location for plots')
    parser.add_argument('--Alabel',dest='Alabel',nargs=1,type=str,
                        default='groupA',help='Optional Label for groupA')
    parser.add_argument('--Blabel',dest='Blabel',nargs=1,type=str,
                        default='groupB',help='Optional Label for groupB')
    parser.add_argument('--out',dest='out',nargs=1,type=str,
                        default=[sys.stdout],help='Output file name.')
    parser.add_argument('--ssnroisA',dest='ssnroisA',nargs='+',type=str,
                        default=[],help='Group A of ssnrois.')
    parser.add_argument('--ssnroisB',dest='ssnroisB',nargs='+',type=str,
                        default=[],help='Group B of ssnrois.')
    parser.add_argument('--filter',dest='filter',nargs=1,type=str,
                        default=[None],help='List of IDs to use.')

    # logging options
    parser.add_argument('--logname',dest='logname',nargs=1,type=str,
                        default=['.'.join(['log.ssnomad',__date,str(__pid)])],
                        help='File name to use for log output.')
    parser.add_argument('--debug',dest='loglevel',action='store_const',
                        const=['DEBUG'],default=['INFO'],help='Enable debug logging.') 

    args = parser.parse_args()
    main(args.ssnroisA,args.ssnroisB,args.Alabel,args.Blabel,args.out[0],args.plots_out)


