#!/usr/bin/env python
# -*- coding: iso-8859-1 -*-


###
#COPYRIGHT © 2013 THE OHIO STATE UNIVERSITY
#ALL RIGHTS RESERVED
#
#PERMISSION IS GRANTED TO USE, COPY, CREATE DERIVATIVE WORKS AND
#REDISTRIBUTE THIS SOFTWARE AND SUCH DERIVATIVE WORKS FOR NONCOMMERCIAL
#EDUCATION AND RESEARCH PURPOSES, SO LONG AS NO FEE IS CHARGED, AND SO
#LONG AS THE COPYRIGHT NOTICE ABOVE, THIS GRANT OF PERMISSION, AND THE
#DISCLAIMER BELOW APPEAR IN ALL COPIES MADE; AND SO LONG AS THE NAME OF
#THE OHIO STATE UNIVERSITY IS NOT USED IN ANY ADVERTISING OR PUBLICITY
#PERTAINING TO THE USE OR DISTRIBUTION OF THIS SOFTWARE WITHOUT
#SPECIFIC, WRITTEN PRIOR AUTHORIZATION.
#
#THIS SOFTWARE IS PROVIDED AS IS, WITHOUT REPRESENTATION FROM THE OHIO
#STATE UNIVERSITY AS TO ITS FITNESS FOR ANY PURPOSE, AND WITHOUT
#WARRANTY BY THE OHIO STATE UNIVERSITY OF ANY KIND, EITHER EXPRESS OR
#IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF
#MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE OHIO STATE
#UNIVERSITY SHALL NOT BE LIABLE FOR ANY DAMAGES, INCLUDING SPECIAL,
#INDIRECT, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, WITH RESPECT TO ANY
#CLAIM ARISING OUT OF OR IN CONNECTION WITH THE USE OF THE SOFTWARE,
#EVEN IF IT HAS BEEN OR IS HEREAFTER ADVISED OF THE POSSIBILITY OF SUCH
#DAMAGES.
###


try:
    import PrEMeR_CG as PCG
    import argparse
except (ImportError),err: raise

def main(out,sam,samtype,cgindex,cdf,ada,nthreads,textout):
    print out,sam,samtype,cgindex,cdf,ada,nthreads
    c = PCG.PrEMeR_CG()
    c.loadsam(sam,samtype)
    c.loadcgindex(cgindex)
    if cdf: c.loadcdf(cdf,ada)
    c.bin(out,textout,nthreads=nthreads)
    return


if __name__ == '__main__':
    parser = argparse.ArgumentParser(description = 'CG Binner')
    parser.add_argument('--out',dest='out',nargs=1,type=str,
                        default=['default'],help='Base name for output files.')
    parser.add_argument(metavar='sam',dest='sam',nargs=1,type=str,
                        help='SAM file to bin.')
    parser.add_argument('--samtype',dest='samtype',nargs=1,type=str,
                        default=['sam'],help='SAM file type.')
    parser.add_argument('--cdf',dest='cdf',nargs=1,type=str,
                        default=[None],help='CDF file to extend by.')
    parser.add_argument('--adapter',dest='ada',nargs=1,type=int,
                        default=[0],help='Length of adapter to trim.')
    parser.add_argument(metavar='cgindex',dest='cgindex',nargs=1,type=str,
                        help='Genome reference CpG index marshal file.')
    parser.add_argument('--nthreads',dest='nthreads',nargs=1,type=int,
                        default=[1],help='Number of threads to use.')
    parser.add_argument('--text', dest='text',action='store_true', help='Output to text file')
    args = parser.parse_args()
    print args.text
    main(args.out[0],args.sam[0],args.samtype[0],args.cgindex[0],args.cdf[0],args.ada[0],args.nthreads[0],args.text)
